#include <runtime/lib.h>
#include <kernel/uos.h>
#include <stream/stream.h>

static stream_interface_t debug_interface = {
	(void (*) (stream_t*, short)) debug_putchar,
	0, 0,
};

int
debug_printf (const char *fmt, ...)
{
	struct {
		stream_interface_t *interface;
	} debug = { &debug_interface };
	va_list	args;
	int err;

	va_start (args, fmt);
	err = vprintf (&debug, fmt, args);
	va_end (args);
	return err;
}

int
debug_vprintf (const char *fmt, va_list args)
{
	struct {
		stream_interface_t *interface;
	} debug = { &debug_interface };

	return vprintf (&debug, fmt, args);
}
