#include <runtime/lib.h>
#include <kernel/uos.h>

#ifndef NDEBUG
#include <kernel/internal.h>

void
__assert_fail (const char *cond, const char *file, unsigned int line,
	const char *func)
{
	task_t *t;

	debug_printf ("Assertion failed in function `%S':\n%S:%u: %S\n",
		func, file, line, cond);

	if (task_active.head) {
		debug_printf ("\n");
		debug_print_task (0);
		for (t=task_active.head; t; t=t->next)
			debug_print_task (t);
		debug_printf ("\n");
	}
	for (;;)
		abort ();
}
#endif
